<?php

namespace FiloBlu\ExtInventory\Plugin\Model\From;

use FiloBlu\ExtInventory\Model\ReservationCalculatorResolver;

/**
 * Class Stock
 * @package FiloBlu\ExtInventory\Plugin\Model\From
 */
class Stock
{
    /**
     * @var ReservationCalculatorResolver
     */
    private $reservationCalculatorResolver;

    /**
     * Stock constructor.
     * @param ReservationCalculatorResolver $reservationCalculatorResolver
     */
    public function __construct(
        ReservationCalculatorResolver $reservationCalculatorResolver
    ) {
        $this->reservationCalculatorResolver = $reservationCalculatorResolver;
    }

    /**
     * @param \FiloBlu\Flow\Model\From\Stock $subject
     * @param callable $proceed
     * @param $sku
     * @param $sourceCode
     * @param array $orderStatuses
     * @return int
     */
    public function aroundGetReservedQuantity23(\FiloBlu\Flow\Model\From\Stock $subject, callable $proceed, $sku, $sourceCode, $orderStatuses = []): int
    {
        $calculator = $this->reservationCalculatorResolver->getCalculator();

        if ($calculator === null) {
            return $proceed($sku, $sourceCode, $orderStatuses);
        }
        return $calculator->getReservationQuantity($sku, $sourceCode, $orderStatuses);
    }
}
